net.sf.saxon.pattern

## Class NodeTest

- java.lang.Object
- - net.sf.saxon.pattern.NodeTest

- All Implemented Interfaces:
    Serializable, ItemType
  Direct Known Subclasses:
    AnyChildNodeTest, AnyNodeTest, CombinedNodeTest, ContentTypeTest, DocumentNodeTest, EmptySequenceTest, LocalNameTest, NamespaceTest, NameTest, NodeKindTest, SchemaAttributeTest, SchemaElementTest

      public abstract class NodeTest
      extends Object
      implements ItemType, Serializable

  A NodeTest is a simple kind of pattern that enables a context-free test of whether a node matches a given node kind and name. There are several kinds of node test: a full name test, a prefix test, and an "any node of a given type" test, an "any node of any type" test, a "no nodes" test (used, e.g. for "@comment()").

  As well as being used to support XSLT pattern matching, NodeTests act as predicates in axis steps, and also act as item types for type matching.

  For use in user-written application calling `NodeInfo.iterateAxis(byte, NodeTest)`, it is possible to write a user-defined subclass of `NodeTest` that implements a single method, `matches(int, NodeName, int)`

  Author:
    Michael H. Kay
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NodeTest()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
    `SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
    `int` | `getFingerprint()` Get the name of the nodes matched by this nodetest, if it matches a specific name.
    `int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
    `ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
    `int` | `getPrimitiveType()` Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
    `IntSet` | `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
    `ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
    `boolean` | `isAtomicType()` Determine whether this item type is an atomic type
    `boolean` | `isAtomizable()` Ask whether values of this type are atomizable
    `boolean` | `isNillable()` Determine whether the content type (if present) is nillable
    `boolean` | `isPlainType()` Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
    `abstract boolean` | `matches(int nodeKind, NodeName name, int annotation)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(Item item, XPathContext context)` Test whether a given item conforms to this type
    `boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
    `boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
    `boolean` | `matchesItem(Item item, boolean allowURIPromotion, Configuration config)` Test whether a given item conforms to this type.
    `void` | `visitNamedSchemaComponents(SchemaComponentVisitor visitor)` Visit all the schema components used in this ItemType definition

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.type.ItemType

      `getDefaultPriority`

- - ### Constructor Detail

    - #### NodeTest

          public NodeTest()

  - ### Method Detail

    - #### matches

          public boolean matches(Item item,
                        XPathContext context)

      Description copied from interface: `ItemType`
      Test whether a given item conforms to this type
      Specified by:
        `matches` in interface `ItemType`
      Parameters:
        `item` - The item to be tested
        `context` - the XPath dynamic evaluation context
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### matchesItem

          public boolean matchesItem(Item item,
                            boolean allowURIPromotion,
                            Configuration config)

      Test whether a given item conforms to this type. This implements a method of the ItemType interface.
      Specified by:
        `matchesItem` in interface `ItemType`
      Parameters:
        `item` - The item to be tested
        `allowURIPromotion` - true of promotion of anyURI to string is permitted
        `config` - the Saxon Configuration
      Returns:
        true if the item is an instance of this type; false otherwise

    - #### getSuperType

          public ItemType getSuperType(TypeHierarchy th)

      Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xs:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

      In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

      Specified by:
        `getSuperType` in interface `ItemType`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the supertype, or null if this type is item()

    - #### getPrimitiveItemType

          public ItemType getPrimitiveItemType()

      Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.
      Specified by:
        `getPrimitiveItemType` in interface `ItemType`
      Returns:
        the corresponding primitive type

    - #### getPrimitiveType

          public int getPrimitiveType()

      Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
      Specified by:
        `getPrimitiveType` in interface `ItemType`
      Returns:
        the node kind matched by this node test

    - #### getFingerprint

          public int getFingerprint()

      Get the name of the nodes matched by this nodetest, if it matches a specific name. Return -1 if the node test matches nodes of more than one name

    - #### isAtomicType

          public boolean isAtomicType()

      Determine whether this item type is an atomic type
      Specified by:
        `isAtomicType` in interface `ItemType`
      Returns:
        true if this is ANY_ATOMIC_TYPE or a subtype thereof

    - #### isPlainType

          public boolean isPlainType()

      Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
      Specified by:
        `isPlainType` in interface `ItemType`
      Returns:
        false: this is not ANY_ATOMIC_TYPE or a subtype thereof

    - #### getAtomizedItemType

          public AtomicType getAtomizedItemType()

      Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
      Specified by:
        `getAtomizedItemType` in interface `ItemType`
      Returns:
        the best available item type of the atomic values that will be produced when an item of this type is atomized, or null if it is known that atomization will throw an error.

    - #### isAtomizable

          public boolean isAtomizable()

      Ask whether values of this type are atomizable
      Specified by:
        `isAtomizable` in interface `ItemType`
      Returns:
        true unless it is known that these items will be elements with element-only content, in which case return false

    - #### matches

          public boolean matches(TinyTree tree,
                        int nodeNr)

      Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object. The default implementation instantiates the node and then calls the method `matches(NodeInfo)`
      Parameters:
        `tree` - the TinyTree containing the node
        `nodeNr` - the number of the node within the TinyTree
      Returns:
        true if the node matches the NodeTest, otherwise false

    - #### matches

          public abstract boolean matches(int nodeKind,
                        NodeName name,
                        int annotation)

      Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.
      Parameters:
        `nodeKind` - The kind of node to be matched
        `name` - identifies the expanded name of the node to be matched. The value should be null for a node with no name.
        `annotation` - The actual content type of the node
      Returns:
        true if the node matches this node tst

    - #### matches

          public boolean matches(NodeInfo node)

      Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes. The default implementation calls the method `matches(int, NodeName, int)`
      Parameters:
        `node` - the node to be matched
      Returns:
        true if the node test is satisfied by the supplied node, false otherwise

    - #### getNodeKindMask

          public int getNodeKindMask()

      Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<
      Returns:
        a combination of bits: 1<

    - #### getContentType

          public SchemaType getContentType()

      Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.
      Returns:
        the type annotation that all nodes matching this NodeTest must satisfy

    - #### getRequiredNodeNames

          public IntSet getRequiredNodeNames()

      Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. If all names are permitted (i.e. there are no constraints on the node name), returns IntUniversalSet.getInstance(). The default implementation returns the universal set.
      Returns:
        the set of integer fingerprints of the node names that this node test can match.

    - #### isNillable

          public boolean isNillable()

      Determine whether the content type (if present) is nillable
      Returns:
        true if the content test (when present) can match nodes that are nilled

    - #### visitNamedSchemaComponents

          public void visitNamedSchemaComponents(SchemaComponentVisitor visitor)
                                          throws XPathException

      Visit all the schema components used in this ItemType definition
      Specified by:
        `visitNamedSchemaComponents` in interface `ItemType`
      Parameters:
        `visitor` - the visitor class to be called when each component is visited
      Throws:
        `XPathException` - if an error occurs

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.